;===============================================================
;  MSX STAR SOLDIER
;
;	マップ処理 続き
;
;===============================================================
;===============================
; bg一行書き込み
;===============================
put_bg_1line:
proc
		ld		b,8
	_lp:
		push	bc
		call	put_bg_1line_1plane
		pop		bc
		djnz	_lp
endp
;===============================
; bg一行書き込みサイクル開始
;===============================
put_bg_1line_cyclestart:
		call	update_cur_bg_adr
		ld		l,h
		ld		h,#88
		ld		(cur_putbg_state),hl
		ret

;===============================
; bg一行1プレーン書き込み
;===============================
put_bg_1line_1plane:
proc
		ld		hl,cur_bg_adr
		ld		e,(hl)
		inc		l
		inc		l
		ld		d,(hl)
		call	set_vram_adr_de
		add		a,4
		ld		(hl),a
		inc		l
		ld		a,(hl)
		inc		(hl)
		ld		l,a
		ld		h,#c2

		; 星のアドレス取得
		ld		de,(cur_bg_adr)
		ld		a,d
		add		a,#c3-#40
		ld		d,a

		ld		b,32
	_lpL:
		ld		a,(hl)
		or		a
		jr		nz,_put
		ld		a,(de)
	_put:
		out		(c),a
		inc		l
		inc		e
		djnz	_lpL

		ret
endp

;===============================
; 次回bg書き込み行更新
;===============================
update_cur_bg_adr:
proc
		ld		hl,(cur_bg_adr)
		ld		de,-#20
		add		hl,de
		bit		6,h
		jr		nz,_set
		ld		h,#43
	_set:
		ld		(cur_bg_adr),hl
		ret
endp




;===============================
; シーン,map進行
; mapデータ展開
;===============================
proc_5ddd:
proc
		ld		hl,#cdde		; if [cdde] == 0:
		ld		a,(hl)				;
		or		a					;
		jr		nz,_5e06			;
									;
		ex		de,hl				; [cf21]++
		ld		hl,#cf21				;
		inc		(hl)					;
		ld		a,(hl)				; if [cf21]:
		or		a						;
		jr		z,_5e00					;
										;
		bit		7,a						; if [cf21] & 0x80:
		ret		nz							;	ret
		cp		#6f						; if [cf21] != 0x6f:
		ret		nz							; ret
		ld		(hl),#80				; [cf21] = 0x80
		ld		a,#ef					; [cdde] = 0xef
		ld		(de),a						;
		ret								; ret
	_5e00:							;
		ld		a,1					; [cdde] = 1
		ld		(de),a					;
		ret							; ret

	_5e06:						;
		inc		(hl)			; [cdde] ++
		ret		nz				; if [cdde]:

		ld		a,(#cf21)		; if [cf21]:
		or		a					;
		jr		z,_1st				;
		cp		#80					; if [cf21] & 0x80:
		ret		nz						;	ret

		ld		hl,(#cde7)
		ld		c,#ce6b+4
		jr		_set
	_1st:
		ld		hl,(#cde5)
		ld		c,#ce6b
	_set:
		ld		b,#ce6b>>8
		ld		a,(bc)
		ld		(#cde3),a
		ld		de,map_data
		ld		(#cddf),de
		jp		DecompressLZSA
endp




;===============================
; 面-mapデータ 対応
;===============================
data_5e40:
		dw	map2_lzsa, map2_lzsa
		dw	map2_lzsa, map1_lzsa
		dw	map1_lzsa, map2_lzsa
		dw	map1_lzsa, map1_lzsa
		dw	map0_lzsa, map1_lzsa
		dw	map2_lzsa, map0_lzsa
		dw	map0_lzsa, map2_lzsa
		dw	map1_lzsa, map1_lzsa
		dw	map2_lzsa, map0_lzsa
		dw	map0_lzsa, map2_lzsa
		dw	map1_lzsa, map1_lzsa
		dw	map2_lzsa, map0_lzsa
		dw	map0_lzsa, map2_lzsa
		dw	map1_lzsa, map1_lzsa
		dw	map2_lzsa, map0_lzsa
		dw	map0_lzsa, map0_lzsa
val_5e40_in_rom_08aa	equ	data_5e40



