;===============================================================
;  MSX STAR SOLDIER
;
;	画面処理
;
;===============================================================

;===============================================================
;
; 各種アドレス修正
;
;===============================================================
;	初期化
val_59b2_in_rom_004e	equ	setup_hkeyi

;	初期化が重くなってきたので処理削除
val_cd_in_rom_19d6		equ	#21

;;	同期確認
;val_b7_in_rom_1c75		equ	#af
;val_64cd_in_rom_1a23	equ	#7676	; タイトル表示のウェイト
;val_cd5c_in_rom_1a25	equ	#7676	; タイトル表示のウェイト
;val_5c64_in_rom_1a27	equ	#7676	; タイトル表示のウェイト

;	BG更新　→　何もしない
val_cd_in_rom_043a	equ	#21

;	SAT更新、仮想SATクリア
val_4f6b_in_rom_02d2	equ	update_disp
val_4f6b_in_rom_02f8	equ	update_disp
val_4f6b_in_rom_038e	equ	update_disp
;val_4f6b_in_rom_0837	equ	update_disp
;val_4f6b_in_rom_083a	equ	update_disp
val_4f6b_in_rom_035f	equ	update_disp_boss_gameover

;	ボス待ち中のBG更新　→　何もしない(SAT更新処理と同じタイミングで更新)
val_cd_in_rom_019d		equ	#21
val_cd_in_rom_015a		equ	#21

; BOSS y座標 初期値
val_b8_in_rom_016f		equ	#b8-1+8 +4
val_88_in_rom_014d		equ	#88-1+8 +4

; BOSS 砲台位置8ドット単位修正をやめる
val_28_in_rom_479f		equ	#00
;val_f8_in_rom_47a4		equ	#ff			; xは補正有効
val_f8_in_rom_47b3		equ	#ff


; GAME OVER時の処理
val_437b_in_rom_033c	equ	#4378


; 自弾位置修正
val_03_in_rom_0d8c		equ	#01
val_0a_in_rom_0d97		equ	#08

; 中ボス位置修正
val_e4_in_rom_57e2		equ	#e2 
val_0c_in_rom_57c6		equ	#0e
val_e4_in_rom_57aa		equ	#e2
val_0c_in_rom_578d		equ	#0e








;===============================================================
;
;	スプライト表示処理
;
;===============================================================
;==============================
; 表示前処理
;	VRAMアドレスセット
;	(o) #cdd7:	xofs
;	(o)	#cdd8:	xofs - mx>>2
;	(o) de':	cur tmp_sat adr
;	(o) c':		scroll ofs
;	(o) hl':	#cdd6 現在枚数
;==============================
prepare_disp:
proc
		ld		a,(0xcddd)		; 非bossフラグ
		or		a
		jp		nz,_normal

	;_boss:
		ld		hl,putsprite_boss
		ld		(putsprite+1),hl

		; xofs = ((mx & 7) -4)& 0xff
		ld		a,(#cf17)	; boss-x
		and		7
		ld		c,a
		sub		4
		ld		(#cdd7),a

		ld		a,c
		exx
		; back_page取得
		ld		hl,back_page
		ld		l,(hl)

		; back_pageのadj-xyをセット
		; adjx : ((mx & 7)+12)& 15
		;ld		a,(#cf17)	; boss-x
		;and		7
		add		a,12
		and		15
		ld		(hl),a

		; back_pageのscr ofs
		inc		l
		ld		a,(boss_scr_y_org)
		ld		c,a
		ld		a,(#cf18)
		add		a,c
		ld		(hl),a
		ld		c,a			; b:scr ofs

		; back_pageのpnt
		; 23-(x/8)にvdp設定値+#10
		inc		l
		ld		a,(#cf17)	; boss-x
		rrca
		rrca
		rrca
		and		#1f
		sub		23
		neg
		add		a,#10
		ld		(hl),a

		jp		_common

	_normal:
		ld		hl,putsprite_normal
		ld		(putsprite+1),hl

		; map-xオフセット
		ld		a,(#cde9)	; mx
		ld		b,a			; mx
		rlca
		rlca
		rlca
		and		7
		ld		(#cf17),a

		; c = mx>>2
		ld		a,b			; mx
		srl		a
		srl		a
		ld		c,a
		; a = xofs = (((mx/4) & 7) -4)& 0xff
		and		7
		ld		b,a
		sub		4
		ld		(#cdd7),a
		; c = xofs - mx>>2
		sub		c
		ld		(#cdd8),a

		ld		a,b			; (mx/4)&7
		exx
		; back_page取得
		ld		hl,back_page
		ld		l,(hl)

		; back_pageのadj-xyをセット
		; adjx : (((mx/4) & 7)+12)& 15
		;ld		a,(0xcde9)	; mx
		;rrca
		;rrca
		;and		7
		add		a,12
		and		15
		ld		(hl),a

		; back_pageのscr ofs
		inc		l
		ld		a,(#cf19)
		neg
		ld		(hl),a
		ld		c,a			; c:scr ofs

		; back_pageのpnt
		inc		l
		ld		a,(#cf17)
		add		a,#10
		ld		(hl),a

		;jp		_common

	_common:
		; tmp_sat adr
		ld		hl,#ce87
		ld		a,(hl)
		ld		e,a
		ld		d,tmp_sat>>8
		; rotate
		add		a,13*4;#3c
		and		#7f
		ld		(hl),a

		; 現在枚数リセット
		ld		hl,#cdd6
		ld		(hl),0
		exx
		ret
endp


;==============================
; スプライト追加
;	(i) ixl:	y
;	(i) ixh:	x
;	(i) iyl:	pattern
;	(i) iyh:	color
;	(i) #cdd7:	xofs
;	(i) #cdd8:	xofs - mx>>2
;	(i) de':	cur tmp_sat adr
;	(i) c':		scroll ofs
;	(i) hl':	#cdd6 現在枚数
;==============================
; 座標変換スプライト追加
putsprite_boss:
proc
		ld		a,(#cdd7)
		or		a
		jp		m,_mns
		add		a,ixh
		ld		ixh,a
		jp		putsprite_fixed
	_mns:
		add		a,ixh
		ld		ixh,a
		jr		c,putsprite_fixed
	_shift:
		add		a,#20
		ret		nc		; hide
		ld		ixh,a
		ld		a,iyh
		or		#80
		ld		iyh,a
		jp		putsprite_fixed
endp
putsprite_normal:
proc
		ld		a,(#cdd8)	; xofs - mx>>2
		ld		c,a				;
		ld		a,ixh
		srl		a
		srl		a
		add		a,c
		jp		m,_mns
		;; a = ex + ex>>2 + xofs - mx>>2	;46
	;_pls:
		add		a,ixh
		ret		c		; hide
		ld		ixh,a
		jp		putsprite_fixed
	_mns:
		add		a,ixh
		ld		ixh,a
		jr		c,putsprite_fixed
	_shift:
		add		a,#20
		ret		nc		; hide
		ld		ixh,a
		ld		a,iyh
		or		#80
		ld		iyh,a
		;jp		putsprite_fixed
endp
;==============================
; スプライト追加
;	(i) ixl:	y
;	(i) ixh:	x
;	(i) iyl:	pattern
;	(i) iyh:	color
;	(i) de':	cur tmp_sat adr
;	(i) c':		scroll ofs
;	(i) hl':	#cdd6 現在枚数
;==============================
putsprite_fixed:
proc
		exx

		ld		a,ixl
		add		a,c				; scr ofs
		cp		#d0
		jp		nz,_sk
		dec		a
	_sk:
		ld		(de),a
		inc		e
		ld		a,ixh
		ld		(de),a
		inc		e
		ld		a,iyl
		ld		(de),a
		inc		e
		ld		a,iyh
		ld		(de),a

		ld		a,e
		add		a,#3c-3
		and		#7f
		ld		e,a

		inc		(hl)			; 現在枚数++
		exx

		ret
endp


;==============================
; スプライト追加後処理
;	(i) de':	cur tmp_sat adr
;	(i) c':		scroll ofs
;	(i) hl':	#cdd6 現在枚数
;==============================
putsprite_after:
proc
		; 空きを埋める
		exx
		ld		a,c
		ex		af,af'
		ld		a,#20
		sub		(hl)
		jr		z,_end_fill
		ld		b,a
		ex		de,hl
		ld		de,#7f3c
		ld		a,#c8
		add		a,c				; scr ofs
		ld		c,a
	_lp_fill:
		ld		(hl),c
		ld		a,l
		add		a,e
		and		d
		ld		l,a
		djnz	_lp_fill
	_end_fill:
		ld		a,c
		sub		#c8
		ld		c,a
		exx

		; SATに転送
		ld		de,(back_sat)
		call	set_vram_adr_de
		ld		hl,tmp_sat
		ld		b,#80
		otir

		; メッセージ表示がないなら終了
		ld		a,(#ce69)
		or		a
		ret		z

		; メッセージ用のスプライト転送
		ld		a,c				; port
		exx
		ld		c,a				; port
		ex		af,af'
		ld		e,a				; scr ofs
		ld		a,(#cdd7)		; x ofs
		ld		d,a					;

		ld		hl,tmp_sat
		ld		b,32
	_lp_msgspr:
		ld		a,(hl)
		sub		e
		out		(c),a
		inc		l
		ld		a,(hl)
		sub		d
		out		(c),a
		inc		l
		outi
		inc		b
		outi
		jp		nz,_lp_msgspr
		exx

		ret
endp




;===============================================================
; 	画面更新処理
;===============================================================
update_disp:
proc
		call	putsprite_after		; SAT更新後処理
		call	#443d				; ステータス行更新、メッセージ表示
		call	star_update			; 星更新
		jp		shift_back_page		; ページフリップ
endp
update_disp_boss_gameover:
		; 敵消して更新
		ld		hl,#c007
		ld		de,#c008
		ld		bc,#5
		ld		(hl),0
		ldir
		call	prepare_disp
		jp		update_disp


;===============================================================
;	clear vram
;		mapBG展開エリア、SAT、仮想SAT、画面 クリアに追加
;===============================================================
proc_4829plus:
		; 元の処理
		call	#0056

		; VRAMクリア追加
		ld		hl,#4000
		ld		bc,#4000
		xor		a
		call	#016b		; BIGFIL

		ld		hl,#3c00
		ld		bc,#0400
		xor		a
		jp		#016b		; BIGFIL
val_0056_in_rom_0844	equ	proc_4829plus



;===============================================================
;	ステージ開始時の画面初期化
;===============================================================
scr_init_for_stage_st:
proc
		call	#47f3		; mapBG展開エリア、SAT、仮想SAT、画面 0xc000-0xc1df map展開エリア [0xc262:7] クリア

		call	star_setup

		; スクロール位置初期値
		ld		hl,#4000+(#3ff&(-4*32))
		ld		(cur_bg_adr),hl
		ld		l,h
		ld		h,#88
		ld		(cur_putbg_state),hl
		ld		a,2
		ld		(cur_bg_y),a

		ld		b,32
	_lp_put:
		push	bc
		;call	star_put
		call	put_bg_1line
		pop		bc
		djnz	_lp_put
		ret
endp
val_47f3_in_rom_000ed	equ	scr_init_for_stage_st



;==============================
; 裏画面ページ切り替え
;==============================
shift_back_page:
proc
		ld		hl,fore_page
		ld		c,(hl)
		inc		l		; back_page
		ld		a,(hl)
		add		a,4
		and		#0f
;		cp		c
;		ret		z

		ld		c,a
		rrca
		rrca
		add		a,#3c

		di
		; back_page
		ld		(hl),c
		; back_sat adr
		inc		l
		inc		l
		ld		(hl),a

	; 星のページ切り替え
		ld		hl,star_back_page
		ld		a,(hl)
		add		a,star_page_size
		cp		star_page_tbl+star_page_size*star_page_cnt
		jr		c,_sw_star_page
		ld		a,star_page_tbl
	_sw_star_page:
		ld		(hl),a

		ei

		ld		b,0		;← bossルーチンで0が前提になってるので、ここで0にしとく
		ret
endp




;===============================================================
;
;	割り込み処理
;
;===============================================================
call_hl:
		jp	(hl)
;==============================
;	割り込み設定
;==============================
setup_hkeyi:
proc
		call	#0041	; 画面表示を禁止

		; vram #4000以降の書き込み
		ld		hl,#fafc
		ld		a,(hl)
		or		8
		ld		(hl),a

		; 画面切り替え時のゴミを消すためのカラーテーブルの準備
		; vdp-port
		ld		a,(#0007)
		ld		c,a
		; vram-ptrセット
		ld		de,#2000
		ld		a,4
		call	set_vram_adr_de3
		; ゼロ埋め
		xor		a
		ld		b,a
	_lp_clr_page3:
		out		(c),a
		djnz	_lp_clr_page3
		dec		d
		jr		nz,_lp_clr_page3

		; ヒットチェック初期化
		call	init_hit_bkts

		; page setting
		ld		hl,disp_page_tbl
		ld		de,#1078	; PNTv,SATv
		ld		b,4			; n-pages,adr
	_lp:
		xor		a
		ld		(hl),a
		inc		l
		ld		(hl),a
		inc		l

		ld		(hl),d
		inc		l
		inc		d			; PNTv+=400

		ld		(hl),e
		inc		l
		inc		e			; SATv+=100
		inc		e

		djnz	_lp
		; fore_page
		ld		(hl),disp_page_tbl
		inc		l
		; back_page
		ld		(hl),disp_page_tbl+4
		inc		l
		; back_sat l
		ld		(hl),0
		call	shift_back_page

		; putsprite_func setup
		ld		a,#c3
		ld		hl,putsprite_normal
		ld		(putsprite),a
		ld		(putsprite+1),hl
		ld		hl,putsprite_normal
		ld		(putsprite_enemy),a
		ld		(putsprite_enemy+1),hl

		; hscan割り込み設定
		ld		hl,hscan_proc_textscreen
		ld		(hscan_proc),hl
		ld		a,hscan_adr+1
		ld		(hscan_adr),a
		ld		hl,#4830
		ld		(hscan_adr+1),hl
		ld		hl,0
		ld		(hscan_adr+3),hl

		; 割り込み処理セット
		di
		ld		a,#c3
		ld		hl,my_hkeyi
		ld		(HKEYI),a
		ld		(HKEYI+1),hl
		ei


		call	#0044	; 画面表示を再開
		jp		0x59b2
endp



;==============================
;	割り込み処理
;==============================
my_hkeyi:
proc
		;VDP入出力ポート取得
		ld		hl,(#0006)
		inc		h
		inc		l
		ld		b,l
		ld		c,h

		;vblankかチェック
		ld		hl,#8f01
		out		(c),l
		out		(c),h
		ld		a,c
		ld		c,b
		in		d,(c)
		ld		c,a

		;ステータスレジスタ0セレクト
		xor		a
		out		(c),a
		out		(c),h

		rrc		d
		jr		c,_hscan
	;垂直帰線割り込み
	;_vblank:
		; スプライト表示停止
		ld		hl,#880a
		out		(c),l
		out		(c),h

		call	hscan_proc_textscreen

		; 表示ページ切り替え
		ld		hl,back_page
		ld		a,(hl)
		sub		4
		and		#0f
		dec		l		; fore_page
		ld		(hl),a

		; 表PGTセット
		ld		hl,star_back_page
		ld		a,(hl)
		sub		star_page_size
		cp		star_page_tbl
		jr		nc,_sw_star_page
		ld		a,star_page_tbl+star_page_size*(star_page_cnt-1)
	_sw_star_page:
		ld		l,a
		ld		a,(hl)
		ld		(star_fore_pgt),a		;13,17,1b

		; hscan番号セット
		ld		hl,#9300+8-2
		out		(c),l
		out		(c),h
		;HSYNC on
		ld		hl,#8012
		out		(c),l
		out		(c),h

		; 同期カウンタ更新
		xor		a
		ld		(0xcdd5),A

		ret

	;水平同期割り込み
	_hscan:
		;HSYNC off
		ld		hl,#8002
		out		(c),l
		out		(c),h

		; タイトル画面のときはこれで終了
		ld		a,(0xcde4)
		or		a
		jr		z, _hscan_cycle_end

		; 色消す(CT:#12000)
		ld		hl,#8a04
		out		(c),l
		out		(c),h

		; 主処理
		ld		hl,(hscan_proc)
		call	call_hl

		; 次段hscan取得
		ld		hl,hscan_adr
		ld		l,(hl)
		ld		a,(hl)
		or		a
		jr		z, _hscan_cycle_end	; BGMを流して終了

		; hscanを次へ
		ld		l,hscan_adr
		inc		(hl)

		; hscan番号セット
		add		a,b
		out		(c),a
		ld		h,#93
		out		(c),h
		;HSYNC on
		ld		hl,#8012
		out		(c),l
		out		(c),h

		ret

	; 全段hscan終了
	_hscan_cycle_end:
		; 割り込みラインインデックス先頭へ
		ld		a,hscan_adr+1
		ld		(hscan_adr),a

		; 次期ライン時処理切り替え
		ld		hl,hscan_proc_textscreen
		ld		(hscan_proc),hl

		; BGM処理
		ld		a,(0xce82)
		or		a
		jp		z,0xb2f7

		ret
endp

hscan_proc_textscreen:
		; sprite attriburte table
		ld		hl,fore_page
		ld		a,(hl)
		add		a,3
		ld		l,a
		ld		a,(hl)
		inc		a
		ld		b,#85

		ld		hl,#80+18 +((#80+23)<<8)
		ld		de,#820e	; pnt:0x3800
		; sprite attriburte table
		out		(c),a
		out		(c),b
		xor		a
		;adjustリセット
		out		(c),a
		out		(c),l
		;scrollリセット
		out		(c),a
		out		(c),h
		;ステータス表示のname tableへ
		out		(c),e
		out		(c),d

		; 文字用PGT(#0000)
		ld		hl,#8403
		; 色戻す(CT:#2000)
		ld		de,#8a00
		out		(c),l
		out		(c),h
		out		(c),e
		out		(c),d

		; 次段hscan処理切り替え
		ld		hl,hscan_proc_mainscreen
		ld		(hscan_proc),hl

		; b:現在のスクロールy=0
		ld		b,a			; b:現在のスクロールy=0
		ret

hscan_proc_mainscreen:
		ld		hl,fore_page
		ld		l,(hl)

		ld		de,#9297
		;set adjust
		outi
		out		(c),d
		;set scroll
		ld		a,(hl)
		outi
		out		(c),e

		ld		de,#8285
		; PNT
		outi
		out		(c),d
		; SAT
		outi
		out		(c),e

		; スプライト表示再開
		ld		hl,#8808
		out		(c),l
		out		(c),h

		; b:現在のスクロールy
		ld		b,a

		; ゲームPGT(#8000/#a000/#c000,13/17/1b)
		ld		h,#84
		ld		a,(star_fore_pgt)
		; 色戻す(CT:#e000)
		ld		de,#8a03
		out		(c),a
		out		(c),h
		out		(c),e
		out		(c),d

		; 次段hscan処理切り替え
		ld		hl,hscan_proc_textscreen
		ld		(hscan_proc),hl

		ret


