#!/bin/bash
asm="StarSoldier-ss.asm"
rom="StarSoldier-ss-v0.0.rom"

for a in `
  cat ${asm} |
  sed -nre "s/[ \t]*(romadr|filler)[ \t]+(#|0x)([0-9a-f]+)[0-9a-f]/\\1 0x00\\30/p" |
  gawk '
    /romadr.+/{ s=strtonum($2) }
    /filler.+/{ e=strtonum($2);
      printf("(");
      for(i=s;i<e;i+=16) printf("%06x|",i);
      printf("%06x)\n",i);
    }'
`
do
  echo "<< `echo ${a} | cut -c2-7` >>"
  xxd -g1 "${rom}" | grep --color=auto -E "${a}: .+00 (00 )+"
done
